unit SendMessage;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TfmSendMessage = class(TForm)
    gbStyle: TGroupBox;
    rbWarning: TRadioButton;
    rbError: TRadioButton;
    rbQuestion: TRadioButton;
    rbInformation: TRadioButton;
    bnSend: TButton;
    bnTry: TButton;
    Label1: TLabel;
    Label2: TLabel;
    cbCaption: TComboBox;
    cbText: TComboBox;
    procedure bnTryClick(Sender: TObject);
    procedure bnSendClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fmSendMessage: TfmSendMessage;
  flag:integer;

implementation

uses ClientUnit;

{$R *.DFM}

// try message-------------------------------------------------------------
procedure TfmSendMessage.bnTryClick(Sender: TObject);

begin
 if rbWarning.Checked then
      Application.MessageBox(Pchar(cbText.Items[cbText.ItemIndex]),
      Pchar(cbCaption.Items[cbCaption.ItemIndex]),MB_ICONWARNING);

 if rbError.Checked then
      Application.MessageBox(Pchar(cbText.Items[cbText.ItemIndex]),
      Pchar(cbCaption.Items[cbCaption.ItemIndex]),MB_ICONERROR);

 if rbQuestion.Checked then
      Application.MessageBox(Pchar(cbText.Items[cbText.ItemIndex]),
      Pchar(cbCaption.Items[cbCaption.ItemIndex]),MB_ICONQUESTION);

 if rbInformation.Checked then
      Application.MessageBox(Pchar(cbText.Items[cbText.ItemIndex]),
      Pchar(cbCaption.Items[cbCaption.ItemIndex]),MB_ICONINFORMATION);

end;


// Send Message ----------------------------------------------------------
procedure TfmSendMessage.bnSendClick(Sender: TObject);
var
str:string;

begin

 if rbWarning.Checked then
      flag:=0;

 if rbError.Checked then
      flag:=1;

 if rbQuestion.Checked then
      flag:=2;

 if rbInformation.Checked then
      flag:=3;


str:='message%'+cbText.Items[cbText.ItemIndex]+
     '%'+cbCaption.Items[cbCaption.ItemIndex]+'%'+IntToStr(flag);

Form1.Client.Socket.SendText(str);

end;



end.
